parent = context.getParentValue()
if (parent.getPortalType() != 'Sale Supply') or (parent.getValidationState() != 'validated'):
  # If this supply line is not in a validated Sale Supply, it does not apply.
  return None


base_category_tuple = ('resource', 'price_currency')

if context.getSourceSection():
  base_category_tuple += ('source_section',)
if context.getDestinationSection():
  base_category_tuple += ('destination_section',)

if context.getSource():
  base_category_tuple += ('source',)
if context.getDestination():
  base_category_tuple += ('destination',)

if context.getSourceProject():
  base_category_tuple += ('source_project',)
if context.getDestinationProject():
  base_category_tuple += ('destination_project',)

#backwards compatibility
mapped_value_property_list = context.getMappedValuePropertyList()
for mapped_property in ('priced_quantity', 'quantity_unit'):
  if not mapped_property in mapped_value_property_list:
    mapped_value_property_list.append(mapped_property)
    context.setMappedValuePropertyList(mapped_value_property_list)

return context.generatePredicate(membership_criterion_base_category_list = base_category_tuple,
                                                 criterion_property_list = ('start_date',))
