# Send an email for the user with a URL, so he can set the password.
from Products.ERP5Type.Errors import UnsupportedWorkflowMethod

reference = None
password = None

person = context.getDestinationSectionValue(portal_type="Person")

if person.getDefaultEmailText() is None:
  person.setDefaultEmailText(context.getDefaultEmailText())

if person.getLanguage() in [None, ""]:
  person.setLanguage(context.getLanguage())

# Should come from subscription condition probably or preference
function_list = ['customer']

open_assignment_list = person.searchFolder(portal_type="Assignment",
                                              validation_state="open")
current_assignment_list = {}
for assignment in open_assignment_list:
  function = assignment.getFunction()
  if function in current_assignment_list:
    current_assignment_list[function].append(assignment)
  else:
    current_assignment_list[function] = [assignment]

for function in function_list:
  if function in current_assignment_list:
    # Update assignment (Reset stop/start dates)
    for assignment in current_assignment_list[function]:
      if assignment.getStartDate() is None or \
        assignment.getStopDate() is None:
        assignment.update()
        assignment.edit(stop_date=None,
                        start_date=None)
        assignment.open(
          comment="Start and Stop reset by Subscription Request")
  else:
    # Create assignment
    assignment = person.newContent(
        portal_type='Assignment',
        title = '%s Assignment' % (function.capitalize()),
        function = function,
        destination_project=context.getSourceProject()
    )

    assignment.open(comment="Created by Subscription Request")

login_list = [x for x in person.objectValues(portal_type=['ERP5 Login', 'Google Login', 'Facebook Login']) \
              if x.getValidationState() == 'validated']

if not login_list:
  raise ValueError('Something is wrong')

login = login_list[0]
# Let's reset password if the user is his first login.
if "%s-FIRST-SUBSCRIBER-LOGIN" % person.getUserId() == login_list[0].getReference():
  login.invalidate()
  login.setReference(person.getDefaultEmailText())
  reference = person.getDefaultEmailText()
  # Update password of the user
  password = person.Person_generatePassword()
  login.setPassword(password)
  login.validate(comment="Updated by Subscription Request")

# Update Roles and Title
try:
  person.validate()
except UnsupportedWorkflowMethod:
  pass

context.activate(activity='SQLQueue').SubscriptionRequest_sendAcceptedNotification(reference, password)

context.order()
